/* SISTEMAS INTEGRADOS TECNISA

NOME: 4008_STPEST_ATUALIZA_ESTOQUE_CONS.SQL

DESCRIO:
Atualizao do estoque consolidado

CRIAO:
05/08/2003 - Alysson
*/

-- ====================================================================
--                  Procedimento para atualizar estoque
--                  ------------ ---- --------- -------
--
--  Parmetros: @P_FILIMOVI   = Cdigo da filial a ser considerada.
--              @P_DTINICIAL  = Data inicial para clculo de estoque.
--              @P_DTFINAL    = Data final para clculo de estoque.
--              @P_CDPRODUTO  = Cdigo do produto a ser evoludo (Opcional).
--
-- Converso para SQLServer: 30/07/2003: Alysson Junio de Carvalho
-- @C:\Win_V4\Sql\End_Conv\SqlServer\4008_STPEST_Atualiza_Estoque_Cons.sql
-- ====================================================================

IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ATUALIZA_ESTOQUE_CONS' AND
              TYPE = 'P' 		       AND
              U.UID = O.UID                    AND
              U.NAME = USER)

DROP PROCEDURE ATUALIZA_ESTOQUE_CONS
GO

CREATE PROCEDURE ATUALIZA_ESTOQUE_CONS
		@P_FILIMOVI   VARCHAR(04),
      @P_PRODUTO    VARCHAR(10),
 		@P_DTINICIAL  DATETIME,
      @P_DTFINAL    DATETIME

AS
   DECLARE @V_FILIAUX       VARCHAR(04);
   DECLARE @V_IDESTONEG     VARCHAR(04);
   DECLARE @V_DTINICIAL     DATETIME;
   DECLARE @V_DTINICAUX     DATETIME;
   DECLARE @V_DTINICEST     DATETIME;
   DECLARE @V_DTINICPOS     DATETIME;
   DECLARE @V_DTFINAL       DATETIME;
   DECLARE @V_COUNTPOS      NUMERIC(15,5);
   DECLARE @V_QTDEESTO      NUMERIC(15,5);
   DECLARE @V_VALRESTO      NUMERIC(15,5);
   DECLARE @V_VALRBRUT      NUMERIC(15,5);
   DECLARE @V_VALRESTOM1    NUMERIC(15,5);
   DECLARE @V_VALRBRUTM1    NUMERIC(15,5);
   DECLARE @V_VALRESTOM2    NUMERIC(15,5);
   DECLARE @V_VALRBRUTM2    NUMERIC(15,5);
   DECLARE @V_QTDEANTE      NUMERIC(15,5);
   DECLARE @V_VRESTANT      NUMERIC(15,5);
   DECLARE @V_VRBRUANT      NUMERIC(15,5);
   DECLARE @V_VRESTANTM1    NUMERIC(15,5);
   DECLARE @V_VRBRUANTM1    NUMERIC(15,5);
   DECLARE @V_VRESTANTM2    NUMERIC(15,5);
   DECLARE @V_VRBRUANTM2    NUMERIC(15,5);
   DECLARE @V_QTDEESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM2 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM2 NUMERIC(15,5);
   DECLARE @V_QTDEANTEPOS   NUMERIC(15,5);
   DECLARE @V_VRESTANTPOS   NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOS   NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRINDICE1     NUMERIC(15,5);
   DECLARE @V_VRINDICE2     NUMERIC(15,5);

   DECLARE @V_DTSALDO       DATETIME;
   DECLARE @V_EXISMOV       VARCHAR(01);
   DECLARE @V_POSIZERO      VARCHAR(01);
   DECLARE @V_DTPOSESTCON   DATETIME;
   DECLARE @V_LANCESTQ    VARCHAR(100);
   DECLARE @V_DTCUSTCALC    DATETIME;
   DECLARE @V_DTRECALCEST   DATETIME;
   DECLARE @V_DTAUXILIAR    DATETIME;
   DECLARE @V_UTILLOTE      VARCHAR(01);
   DECLARE @V_UTILALMO      VARCHAR(01);

   DECLARE @V_QTDEAJUSTE    NUMERIC(15,5);
   DECLARE @V_VLRESTOAJU    NUMERIC(15,5);
   DECLARE @V_VLRBRUTAJU    NUMERIC(15,5);
   DECLARE @V_VLRESTOAJUM1  NUMERIC(15,5);
   DECLARE @V_VLRBRUTAJUM1  NUMERIC(15,5);
   DECLARE @V_VLRESTOAJUM2  NUMERIC(15,5);
   DECLARE @V_VLRBRUTAJUM2  NUMERIC(15,5);

   DECLARE @V_CDINDICEMF    VARCHAR(04);
   DECLARE @V_CDINDICEMF2   VARCHAR(04);

   DECLARE @V_CDTPINDICE    VARCHAR(01);
   DECLARE @V_IDPERVALOR    VARCHAR(01);
   DECLARE @V_CDTPINDICE2   VARCHAR(01);
   DECLARE @V_IDPERVALOR2   VARCHAR(01);

   DECLARE @V_IDTIPOMOVI    VARCHAR(01);
   DECLARE @V_DTLANCMOVI    DATETIME;
   DECLARE @V_VRLANCTOEST   NUMERIC(15,5);
   DECLARE @V_VRLANCTOBRUT  NUMERIC(15,5);
   DECLARE @V_QTLANCTOEST   NUMERIC(15,5);
   DECLARE @V_IDALTCMEDMV   VARCHAR(01);
   DECLARE @V_CDFILIAL      VARCHAR(04);
   DECLARE @V_NRLANCESTOQ   VARCHAR(10);
   DECLARE @V_CDALMOXARIFE  VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ  VARCHAR(06);
   DECLARE @V_NRLOTEESTQ    VARCHAR(20);
   DECLARE @V_NRSUBLOTE     VARCHAR(04);
   DECLARE @V_MENSAGEM      VARCHAR(200);

   DECLARE @POSESTDIA_CDFILIAL     VARCHAR(04);
   DECLARE @POSESTDIA_CDPRODUTO    VARCHAR(10);
   DECLARE @POSESTDIA_DTPOSIESTQ   DATETIME;
   DECLARE @POSESTDIA_QTESTOQDIA   NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQDIA   NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQDIAM1 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQDIAM2 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQBRUT  NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQBRUM1 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQBRUM2 NUMERIC(15,5);
   DECLARE @POSESTDIA_QTESTOQANT   NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQANT   NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQANTM1 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRESTOQANTM2 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRBRUTOANT   NUMERIC(15,5);
   DECLARE @POSESTDIA_VRBRUTOANTM1 NUMERIC(15,5);
   DECLARE @POSESTDIA_VRBRUTOANTM2 NUMERIC(15,5);
   DECLARE @POSESTDIA_DTCUSTANT    DATETIME;
   DECLARE @POSESTDIA_IDPOSIZERO   VARCHAR(01);
   DECLARE @V_VRQTANT       DOUBLE PRECISION;
   DECLARE @V_TIPCUSTEST    NUMERIC(15,5);

   DECLARE @V_VRCLOGCON     NUMERIC(15,5);
   DECLARE @V_VRCLOGCONANT  NUMERIC(15,5);
   DECLARE @V_VRCLOGCONM1   NUMERIC(15,5);
   DECLARE @V_VRCLOGCONAM1  NUMERIC(15,5);
   DECLARE @V_VRCLOGCONM2   NUMERIC(15,5);
   DECLARE @V_VRCLOGCONAM2  NUMERIC(15,5);
   DECLARE @V_VRSEGUCON     NUMERIC(15,5);
   DECLARE @V_VRSEGUCONANT  NUMERIC(15,5);
   DECLARE @V_VRSEGUCONM1   NUMERIC(15,5);
   DECLARE @V_VRSEGUCONAM1  NUMERIC(15,5);
   DECLARE @V_VRSEGUCONM2   NUMERIC(15,5);
   DECLARE @V_VRSEGUCONAM2  NUMERIC(15,5);
   DECLARE @V_VRCUSTLOGLAN  NUMERIC(15,5);
   DECLARE @V_VRSEGULOGLAN  NUMERIC(15,5);
   DECLARE @V_VRESTOANT     NUMERIC(15,5);
   DECLARE @V_CUSTPROD      NUMERIC;
   DECLARE @V_CDTIPOOPER    VARCHAR(02);
   DECLARE @V_MSG1          VARCHAR(500);

BEGIN

   SELECT @V_CDTPINDICE = ISNULL(CDTPINDICE,'1'),
          @V_IDPERVALOR = ISNULL(IDPERVALOR,'2'),
          @V_CDINDICEMF = CDINDICEMF,
          @V_CDTPINDICE2 = ISNULL(CDTPINDICE2,'1'),
          @V_IDPERVALOR2 = ISNULL(IDPERVALOR2,'2'),
          @V_CDINDICEMF2 = CDINDICEMF2
   FROM PARAMGERAL;
   
   SELECT @V_UTILLOTE = MAX(IDUTILLOTE),
          @V_UTILALMO = MAX(IDUTILALMOX),
          @V_TIPCUSTEST =  ISNULL(MAX(CONVERT(NUMERIC,CDTIPCUSTEST)),3)
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILIMOVI;

   IF (ISNULL(@V_UTILLOTE, 'N') = 'S') OR (ISNULL(@V_UTILALMO, 'N') = 'S')  BEGIN

      SELECT @V_DTRECALCEST = MAX(DTRECALCEST)
      FROM PRODLCESTOQ
      WHERE (CDFILIAL  = @P_FILIMOVI) AND
            (CDPRODUTO = @P_PRODUTO);

     /* ATUALIZA AS DATAS INICIAL/FINAL PARA ATUALIZAR TODO PERODO */
      SELECT @V_DTINICEST = MIN(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI = @P_FILIMOVI) AND
            (CDPRODMOVI = @P_PRODUTO);

      SELECT @V_DTINICPOS = MIN(DTPOSESTCON)
      FROM POSESTCONS
      WHERE (CDFILIAL  = @P_FILIMOVI) AND
            (CDPRODUTO = @P_PRODUTO);

      /* DATA INICIAL */

      IF NOT(@V_DTRECALCEST IS NULL) AND
         (@V_DTRECALCEST < @P_DTINICIAL) BEGIN
          SET @V_DTINICIAL =  @V_DTRECALCEST;
      END
      ELSE BEGIN
         SET @V_DTINICIAL = @P_DTINICIAL;
      END;

      IF NOT(@V_DTINICEST IS NULL) OR
         NOT(@V_DTINICPOS IS NULL) BEGIN

         IF NOT(@V_DTINICEST IS NULL) BEGIN
            SET @V_DTINICAUX = @V_DTINICEST;
         END;

         IF NOT(@V_DTINICPOS IS NULL) BEGIN
            IF (@V_DTINICPOS <  @V_DTINICAUX) BEGIN
                SET @V_DTINICAUX = @V_DTINICPOS;
            END;
         END;

         IF (@V_DTINICIAL <  @V_DTINICAUX) BEGIN
             SET @V_DTINICIAL = @V_DTINICAUX;
         END;

         DELETE POSESTCONS
         WHERE (CDFILIAL     = @P_FILIMOVI)  AND
               (CDPRODUTO    = @P_PRODUTO)   AND
               (DTPOSESTCON <= @V_DTINICEST) AND
               (VRCUSPRLISTP IS NULL);
      END;

      /* DATA FINAL */
      SELECT @V_DTFINAL = MAX(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI = @P_FILIMOVI) AND
            (CDPRODMOVI = @P_PRODUTO);

      IF @V_DTFINAL IS NULL BEGIN
         SET @V_DTFINAL = @P_DTFINAL;
      END
      ELSE BEGIN
         IF (@V_DTFINAL <= @P_DTFINAL) BEGIN
             SET @V_DTFINAL = @P_DTFINAL;
         END;
      END;

      SELECT @V_QTDEESTOPOS   = ISNULL(MAX(QTESTDIACON),0),
             @V_VALRESTOPOS   = ISNULL(MAX(VRESTDIACON),0),
             @V_VALRBRUTPOS   = ISNULL(MAX(VRESTBRUTCON),0),
             @V_VALRESTOPOSM1 = ISNULL(MAX(VRESTDIACOM1),0),
             @V_VALRBRUTPOSM1 = ISNULL(MAX(VRESTBRUTCM1),0),
             @V_VALRESTOPOSM2 = ISNULL(MAX(VRESTDIACOM2),0),
             @V_VALRBRUTPOSM2 = ISNULL(MAX(VRESTBRUTCM2),0),
             @V_QTDEANTEPOS   = ISNULL(MAX(QTESTANTCON),0) ,
             @V_VRESTANTPOS   = ISNULL(MAX(VRESTANTCON),0) ,
             @V_VRBRUANTPOS   = ISNULL(MAX(VRBRUTANTCON),0),
             @V_VRESTANTPOSM1 = ISNULL(MAX(VRESTANTCOM1),0) ,
             @V_VRBRUANTPOSM1 = ISNULL(MAX(VRBRUTANTCM1),0),
             @V_VRESTANTPOSM2 = ISNULL(MAX(VRESTANTCOM2),0) ,
             @V_VRBRUANTPOSM2 = ISNULL(MAX(VRBRUTANTCM2),0),
             @V_DTAUXILIAR    = MAX(DTPOSESTCON),
             @V_VRCLOGCON     =   ISNULL(MAX(VRCLOGCON),0),
             @V_VRCLOGCONANT  =   ISNULL(MAX(VRCLOGCONANT),0),
             @V_VRCLOGCONM1   =   ISNULL(MAX(VRCLOGCONM1),0),
             @V_VRCLOGCONAM1  =   ISNULL(MAX(VRCLOGCONAM1),0),
             @V_VRCLOGCONM2   =   ISNULL(MAX(VRCLOGCONM2),0),
             @V_VRCLOGCONAM2  =   ISNULL(MAX(VRCLOGCONAM2),0),
             @V_VRSEGUCON     =   ISNULL(MAX(VRSEGUCON),0),
             @V_VRSEGUCONANT  =   ISNULL(MAX(VRSEGUCONANT),0),
             @V_VRSEGUCONM1   =   ISNULL(MAX(VRSEGUCONM1),0),
             @V_VRSEGUCONAM1  =   ISNULL(MAX(VRSEGUCONAM1),0),
             @V_VRSEGUCONM2   =   ISNULL(MAX(VRSEGUCONM2),0),
             @V_VRSEGUCONAM2  =   ISNULL(MAX(VRSEGUCONAM2),0)
      FROM POSESTCONS
      WHERE (CDFILIAL     = @P_FILIMOVI) AND
            (CDPRODUTO    = @P_PRODUTO) AND
            (DTPOSESTCON  = @V_DTINICIAL);

      IF (@@ROWCOUNT = 0) BEGIN
         SELECT @V_QTDEESTOPOS   = ISNULL(MAX(QTESTDIACON),0) ,
                @V_VALRESTOPOS   = ISNULL(MAX(VRESTDIACON),0) ,
                @V_VALRBRUTPOS   = ISNULL(MAX(VRESTBRUTCON),0),
                @V_VALRESTOPOSM1 = ISNULL(MAX(VRESTDIACOM1),0) ,
                @V_VALRBRUTPOSM1 = ISNULL(MAX(VRESTBRUTCM1),0),
                @V_VALRESTOPOSM2 = ISNULL(MAX(VRESTDIACOM2),0) ,
                @V_VALRBRUTPOSM2 = ISNULL(MAX(VRESTBRUTCM2),0),
                @V_QTDEANTEPOS   = ISNULL(MAX(QTESTANTCON),0) ,
                @V_VRESTANTPOS   = ISNULL(MAX(VRESTANTCON),0) ,
                @V_VRBRUANTPOS   = ISNULL(MAX(VRBRUTANTCON),0),
                @V_VRESTANTPOSM1 = ISNULL(MAX(VRESTANTCOM1),0) ,
                @V_VRBRUANTPOSM1 = ISNULL(MAX(VRBRUTANTCM1),0),
                @V_VRESTANTPOSM2 = ISNULL(MAX(VRESTANTCOM2),0) ,
                @V_VRBRUANTPOSM2 = ISNULL(MAX(VRBRUTANTCM2),0),
                @V_DTAUXILIAR    = MAX(DTPOSESTCON),
                @V_VRCLOGCON     =   ISNULL(MAX(VRCLOGCON),0),
                @V_VRCLOGCONANT  =   ISNULL(MAX(VRCLOGCONANT),0),
                @V_VRCLOGCONM1   =   ISNULL(MAX(VRCLOGCONM1),0),
                @V_VRCLOGCONAM1  =   ISNULL(MAX(VRCLOGCONAM1),0),
                @V_VRCLOGCONM2   =   ISNULL(MAX(VRCLOGCONM2),0),
                @V_VRCLOGCONAM2  =   ISNULL(MAX(VRCLOGCONAM2),0),
                @V_VRSEGUCON     =   ISNULL(MAX(VRSEGUCON),0),
                @V_VRSEGUCONANT  =   ISNULL(MAX(VRSEGUCONANT),0),
                @V_VRSEGUCONM1   =   ISNULL(MAX(VRSEGUCONM1),0),
                @V_VRSEGUCONAM1  =   ISNULL(MAX(VRSEGUCONAM1),0),
                @V_VRSEGUCONM2   =   ISNULL(MAX(VRSEGUCONM2),0),
                @V_VRSEGUCONAM2  =   ISNULL(MAX(VRSEGUCONAM2),0)
         FROM POSESTCONS
         WHERE (CDFILIAL     = @P_FILIMOVI) AND
               (CDPRODUTO    = @P_PRODUTO) AND
               (DTPOSESTCON  = (SELECT MAX(DTPOSESTCON)
                                FROM POSESTCONS
                                WHERE (CDFILIAL     = @P_FILIMOVI) AND
                                      (CDPRODUTO    = @P_PRODUTO) AND
                                      (DTPOSESTCON  < @V_DTINICIAL)));
      END;

      DELETE POSESTCONS
      WHERE (CDFILIAL     = @P_FILIMOVI)  AND
            (CDPRODUTO    = @P_PRODUTO)   AND
            (DTPOSESTCON  > @V_DTINICIAL) AND
            (VRCUSPRLISTP IS NULL);

      /* ATUALIZA SALDO DE ESTOQUE DESDE A DATA INICIAL */
      /* AT A DATA DE PROCESSAMENTO                    */

      SET @V_EXISMOV = 'N';
      SET @V_DTSALDO = @V_DTINICIAL;
      SET @V_LANCESTQ = 'X';

      SET @V_QTDEESTO   = @V_QTDEESTOPOS;

      SET @V_VALRESTO   = @V_VALRESTOPOS;
      SET @V_VALRBRUT   = @V_VALRBRUTPOS;
      SET @V_VALRESTOM1 = @V_VALRESTOPOSM1;
      SET @V_VALRBRUTM1 = @V_VALRBRUTPOSM1;
      SET @V_VALRESTOM2 = @V_VALRESTOPOSM2;
      SET @V_VALRBRUTM2 = @V_VALRBRUTPOSM2;
      SET @V_QTDEANTE   = @V_QTDEANTEPOS;
      SET @V_VRESTANT   = @V_VRESTANTPOS;
      SET @V_VRBRUANT   = @V_VRBRUANTPOS;
      SET @V_VRESTANTM1 = @V_VRESTANTPOSM1;
      SET @V_VRBRUANTM1 = @V_VRBRUANTPOSM1;
      SET @V_VRESTANTM2 = @V_VRESTANTPOSM2;
      SET @V_VRBRUANTM2 = @V_VRBRUANTPOSM2;

     IF (@V_QTDEESTO <> 0) BEGIN
         SET @V_QTDEANTE   = @V_QTDEESTOPOS;
         SET @V_VRESTANT   = @V_VRESTANTPOS;
         SET @V_VRBRUANT   = @V_VALRBRUTPOS;
         SET @V_VRESTANTM1 = @V_VRESTANTPOSM1;
         SET @V_VRBRUANTM1 = @V_VALRBRUTPOSM1;
         SET @V_VRESTANTM2 = @V_VRESTANTPOSM2;
         SET @V_VRBRUANTM2 = @V_VALRBRUTPOSM2;

      END;

      DECLARE C_LANCTOEST CURSOR FOR
         SELECT I.IDTIPOMOVI,   I.DTLANCMOVI,  ISNULL(I.VRLANCTOEST, 0) VRLANCTOEST,
                ISNULL(I.VRLANCTOBRUT,0) VRLANCTOBRUT, I.QTLANCTOEST, IDALTCMEDMV,
                I.CDFILIAL,  I.NRLANCESTQ,  I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ,
                I.NRSUBLOTE, I.VRCUSTLOGLAN, I.VRSEGULOGLAN, L.CDTIPOOPER
         FROM ITLANCTOEST I, LANCTOESTOQ L, PARAMFILIAL P, PRODFILI PF
         WHERE (I.CDFILIMOVI   = @P_FILIMOVI)
           AND (I.CDPRODMOVI   = @P_PRODUTO)
           AND (I.CDFILIAL     = L.CDFILIAL)
           AND (I.NRLANCESTQ   = L.NRLANCESTQ)
           AND (I.DTLANCMOVI   >= @V_DTINICIAL)
           AND (I.DTLANCMOVI   <= @V_DTFINAL)
           AND (I.CDFILIMOVI   = P.CDFILIAL      )
           AND (I.CDFILIMOVI   = PF.CDFILIAL     )
           AND (I.CDPRODMOVI   = PF.CDPRODUTO  )
           AND (ISNULL(I.IDEVOLESTOQ,'S') = 'S' )
           AND (((P.IDUTILALMOX = 'S') AND(I.CDALMOXARIFE <> ' '))OR((P.IDUTILALMOX = 'N' )AND(I.CDALMOXARIFE = ' ')))
           AND (((P.IDUTILLCESTQ = 'S')AND(I.CDLOCALESTOQ <> ' '))OR((P.IDUTILLCESTQ = 'N') AND (I.CDLOCALESTOQ = ' ')))
           AND ((P.IDUTILLOTE  = 'S') AND(((PF.IDUTCTRLLOTE = 'S') AND(I.NRLOTEESTQ <>' '))OR
                                          ((PF.IDUTCTRLLOTE = 'N')AND( I.NRLOTEESTQ = ' ')))OR
                                          (P.IDUTILLOTE  = 'N') AND ( I.NRLOTEESTQ = ' '))
         ORDER BY I.DTLANCMOVI, ISNULL(I.IDORDEMCLC,I.IDTIPOMOVI), I.NRLANCESTQ, I.NRSEQUITEM;

      OPEN C_LANCTOEST
      FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,  @V_VRLANCTOEST,
                                       @V_VRLANCTOBRUT, @V_QTLANCTOEST, @V_IDALTCMEDMV,
                                       @V_CDFILIAL,     @V_NRLANCESTOQ, @V_CDALMOXARIFE,
                                       @V_CDLOCALESTOQ, @V_NRLOTEESTQ,  @V_NRSUBLOTE,
                                       @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN, @V_CDTIPOOPER;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF ISNULL(@V_CDINDICEMF,0)<>0 BEGIN
            SELECT @V_VRINDICE1 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE AND
                  I.IDPERVALOR  = @V_IDPERVALOR AND
                  I.CDINDICE    = @V_CDINDICEMF AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;
            IF (ISNULL(@V_VRINDICE1,0) = 0) BEGIN
               SET @V_MSG1 = 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '+CONVERT(VARCHAR, @V_DTLANCMOVI, 103);
               RAISERROR(@V_MSG1, 16,1);
            END;
         END;

         IF ISNULL(@V_CDINDICEMF2,0)<>0 BEGIN
            SELECT @V_VRINDICE2 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE2 AND
                  I.IDPERVALOR  = @V_IDPERVALOR2 AND
                  I.CDINDICE    = @V_CDINDICEMF2 AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;
            SET @V_MSG1 = 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '+CONVERT(VARCHAR, @V_DTLANCMOVI, 103);
            IF (ISNULL(@V_VRINDICE2,0) = 0) BEGIN
               RAISERROR(@V_MSG1, 16,1);
            END;
         END;

         IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN
             SET @V_DTSALDO = @V_DTLANCMOVI + 1;
         END;

         IF (@V_QTDEESTO <> 0) BEGIN
            SET @V_QTDEANTE   = @V_QTDEESTO;
            SET @V_VRESTANT   = @V_VALRESTO;
            SET @V_VRBRUANT   = @V_VALRBRUT;
            SET @V_VRESTANTM1 = @V_VALRESTOM1;
            SET @V_VRBRUANTM1 = @V_VALRBRUTM1;
            SET @V_VRESTANTM2 = @V_VALRESTOM2;
            SET @V_VRBRUANTM2 = @V_VALRBRUTM2;
         END;

         IF (@V_DTLANCMOVI + 1) = @V_DTAUXILIAR BEGIN
            SET @V_QTDEESTO   = 0;
            SET @V_VALRESTO   = 0;
            SET @V_VALRBRUT   = 0;
            SET @V_VALRESTOM1 = 0;
            SET @V_VALRBRUTM1 = 0;
            SET @V_VALRESTOM2 = 0;
            SET @V_VALRBRUTM2 = 0;
            SET @V_QTDEANTE   = 0;
            SET @V_VRESTANT   = 0;
            SET @V_VRBRUANT   = 0;
            SET @V_VRESTANTM1 = 0;
            SET @V_VRBRUANTM1 = 0;
            SET @V_VRESTANTM2 = 0;
            SET @V_VRBRUANTM2 = 0;

         END;

         SET @V_EXISMOV = 'S';

         /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO */

         /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */

         /* ATUALIZAO REALIZADA NA DATA 22/06/2009 SOLICITAO 78472 */

         IF (@V_IDTIPOMOVI = '0') BEGIN    /* IMPLANTAO */
            IF (@V_LANCESTQ <> @V_CDFILIAL+ @V_NRLANCESTOQ+ @V_CDALMOXARIFE +
                                           @V_CDLOCALESTOQ + @V_NRLOTEESTQ +
                                           @V_NRSUBLOTE        ) BEGIN
               EXEC CALCULA_SALDO_ANTERIOR @V_CDFILIAL, @V_NRLANCESTOQ,
                                           @P_FILIMOVI, @P_PRODUTO, @V_CDALMOXARIFE,
                                           @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                           @V_NRSUBLOTE, @V_DTLANCMOVI, 'N',
                                           @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                           @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                           @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                           @P_QTESTOQANT  = @V_VRQTANT OUTPUT,
                                           @P_VRESTANT    = @V_VRESTOANT OUTPUT;

               SET @V_QTDEESTO = @V_QTDEESTO + (@V_QTLANCTOEST  - @V_QTDEAJUSTE);

               IF (@V_QTDEAJUSTE <> 0) BEGIN
                  SET @V_VALRESTO = @V_VALRESTO + (@V_VRLANCTOEST  - @V_VLRESTOAJU);
                  SET @V_VALRBRUT = @V_VALRBRUT + (@V_VRLANCTOBRUT - @V_VLRBRUTAJU);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
                  SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
               END;
            END
            ELSE BEGIN
               SET @V_QTDEESTO = @V_QTDEESTO + @V_QTLANCTOEST;
               SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
               SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
            END; 

         END
         ELSE IF (@V_IDTIPOMOVI = '1') BEGIN    /* AJUSTES     */
            EXEC CALCULA_SALDO_ANTERIOR @V_CDFILIAL, @V_NRLANCESTOQ,
                                        @P_FILIMOVI, @P_PRODUTO, @V_CDALMOXARIFE,
                                        @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                        @V_NRSUBLOTE, @V_DTLANCMOVI,'N',
                                        @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                        @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                        @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                        @P_QTESTOQANT  = @V_VRQTANT OUTPUT,
                                        @P_VRESTANT    = @V_VRESTOANT OUTPUT;

            IF ISNULL(@V_IDALTCMEDMV, 'N') <> 'S' BEGIN
               IF (@V_QTDEAJUSTE <> 0) BEGIN
                  SET @V_VRBRUANT = @V_VALRBRUT;
                  SET @V_VRESTANT = @V_VALRESTO;
                  SET @V_QTDEANTE = @V_QTDEESTO;

                  SET @V_VALRBRUT = @V_VALRBRUT + ((@V_VLRBRUTAJU/@V_QTDEAJUSTE)*(@V_QTLANCTOEST - @V_QTDEAJUSTE));
                  SET @V_VALRESTO = @V_VALRESTO + ((@V_VLRESTOAJU/@V_QTDEAJUSTE)*(@V_QTLANCTOEST - @V_QTDEAJUSTE));
               END
               ELSE BEGIN
                  IF (@V_VLRESTOAJU = 0) BEGIN
                     IF ABS(@V_VRQTANT) > 0 AND ABS(@V_QTLANCTOEST) > 0 BEGIN
                        SET @V_VALRBRUT = @V_VALRBRUT + (@V_VRESTOANT/@V_VRQTANT)* @V_QTLANCTOEST;
                        SET @V_VALRESTO = @V_VALRESTO + (@V_VRESTOANT/@V_VRQTANT)* @V_QTLANCTOEST;
                     END;
                  END
                  ELSE BEGIN
                     IF ABS(@V_VRQTANT) > 0 BEGIN
                        SET @V_VALRBRUT = @V_VALRBRUT + ((@V_VLRBRUTAJU/@V_VRQTANT)* @V_QTLANCTOEST);
                        SET @V_VALRESTO = @V_VALRESTO + ((@V_VLRESTOAJU/@V_VRQTANT)*@V_QTLANCTOEST);
                     END;
                  END;
               END;
            END;
            SET @V_QTDEESTO = @V_QTDEESTO + (@V_QTLANCTOEST - @V_QTDEAJUSTE);
         END
         ELSE IF (@V_IDTIPOMOVI = '2') BEGIN    /* ENTRADA     */
            IF (@V_QTLANCTOEST <> 0 OR @V_CDTIPOOPER = '03') BEGIN
               SET @V_QTDEESTO  = @V_QTDEESTO + @V_QTLANCTOEST;
               SET @V_VRCLOGCON = @V_VRCLOGCON + @V_VRCUSTLOGLAN;
               SET @V_VRSEGUCON = @V_VRSEGUCON + @V_VRSEGULOGLAN;

               IF @V_QTLANCTOEST = 0 BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
                  SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT + (@V_QTLANCTOEST * @V_VRLANCTOBRUT);
                  SET @V_VALRESTO = @V_VALRESTO + (@V_QTLANCTOEST * @V_VRLANCTOEST);
               END;

               IF @V_QTDEESTO  = 0 BEGIN
                  SET @V_VALRBRUT = 0;
                  SET @V_VALRESTO = 0;
               END;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '3') BEGIN    /* RETIRADA    */
            EXEC CALCULA_SALDO_ANTERIOR @V_CDFILIAL,   @V_NRLANCESTOQ,  @P_FILIMOVI,
                                        @P_PRODUTO,    @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                        @V_NRLOTEESTQ, @V_NRSUBLOTE,    @V_DTLANCMOVI,'N',
                                        @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                        @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                        @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                        @P_QTESTOQANT  = @V_VRQTANT OUTPUT,
                                        @P_VRESTANT    = @V_VRESTOANT OUTPUT;

            IF (@V_QTDEAJUSTE <> 0) BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VLRBRUTAJU/@V_QTDEAJUSTE)*@V_QTLANCTOEST);
               SET @V_VALRESTO = @V_VALRESTO - ((@V_VLRESTOAJU/@V_QTDEAJUSTE)*@V_QTLANCTOEST);
            END
            ELSE BEGIN
               IF @V_VRQTANT > 0 BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VLRBRUTAJU/@V_VRQTANT)*@V_QTLANCTOEST);
                  SET @V_VALRESTO = @V_VALRESTO - ((@V_VLRESTOAJU/@V_VRQTANT)*@V_QTLANCTOEST);
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - (@V_VLRBRUTAJU*@V_QTLANCTOEST);
                  SET @V_VALRESTO = @V_VALRESTO - (@V_VLRESTOAJU*@V_QTLANCTOEST);
               END;
            END;
            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

            IF ROUND(@V_QTDEESTO,8) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF (@V_QTDEESTO  = 0) BEGIN
               SET @V_VALRBRUT   = 0;
               SET @V_VALRESTO   = 0;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '4') BEGIN    /* SADA       */
            IF (@V_QTLANCTOEST <> 0 OR @V_CDTIPOOPER = '03') BEGIN
               EXEC CALCULA_SALDO_ANTERIOR @V_CDFILIAL,   @V_NRLANCESTOQ,  @P_FILIMOVI,
                                           @P_PRODUTO,    @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                           @V_NRLOTEESTQ, @V_NRSUBLOTE,    @V_DTLANCMOVI,'N',
                                           @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                           @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                           @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                           @P_QTESTOQANT  = @V_VRQTANT OUTPUT,
                                           @P_VRESTANT    = @V_VRESTOANT OUTPUT;

               IF (@V_QTDEAJUSTE <> 0) BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VLRBRUTAJU/@V_QTDEAJUSTE)*@V_QTLANCTOEST);
                  SET @V_VALRESTO = @V_VALRESTO - ((@V_VLRESTOAJU/@V_QTDEAJUSTE)*@V_QTLANCTOEST);
               END
               ELSE BEGIN
                  IF @V_VRQTANT > 0 BEGIN
                     SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VLRBRUTAJU/@V_VRQTANT)*@V_QTLANCTOEST);
                     SET @V_VALRESTO = @V_VALRESTO - ((@V_VLRESTOAJU/@V_VRQTANT)*@V_QTLANCTOEST);
                  END
                  ELSE BEGIN
                     SET @V_VALRBRUT = @V_VALRBRUT - (@V_VLRBRUTAJU*@V_QTLANCTOEST);
                     SET @V_VALRESTO = @V_VALRESTO - (@V_VLRESTOAJU*@V_QTLANCTOEST);
                  END;
               END;
               SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

               IF (ROUND(@V_QTDEESTO,8) = 0) BEGIN
                  SET @V_QTDEESTO = 0;
               END;

               IF (@V_QTDEESTO  = 0) BEGIN
                  SET @V_VALRBRUT   = 0;
                  SET @V_VALRESTO   = 0;
               END;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '5') BEGIN    /* DEV. FORN.  */

         EXEC CALCULA_SALDO_ANTERIOR @V_CDFILIAL,   @V_NRLANCESTOQ,  @P_FILIMOVI,
                                        @P_PRODUTO,    @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                        @V_NRLOTEESTQ, @V_NRSUBLOTE,    @V_DTLANCMOVI,'N',
                                        @P_QTESTOQDIA  = @V_QTDEAJUSTE OUTPUT,
                                        @P_VRESTOQDIA  = @V_VLRESTOAJU OUTPUT,
                                        @P_VRESTOQBRUT = @V_VLRBRUTAJU OUTPUT,
                                        @P_QTESTOQANT  = @V_VRQTANT OUTPUT,
                                        @P_VRESTANT    = @V_VRESTOANT OUTPUT;

            IF @V_QTDEAJUSTE <> 0 BEGIN
               SET @V_CUSTPROD =  @V_VLRESTOAJU/@V_QTDEAJUSTE;
            END
            ELSE BEGIN
               SET @V_CUSTPROD =  @V_VLRESTOAJU;
            END;

            IF (@V_VALRESTO - (@V_QTLANCTOEST * @V_VRLANCTOEST)) < 0 BEGIN
                 SET @V_VALRESTO = @V_VALRESTO - (@V_QTLANCTOEST * @V_CUSTPROD);
            END
            ELSE BEGIN
                 SET @V_VALRESTO = (@V_VALRESTO - (@V_QTLANCTOEST * @V_VRLANCTOEST));
            END;

            IF @V_QTDEAJUSTE <> 0 BEGIN
               SET @V_CUSTPROD =  @V_VLRBRUTAJU/@V_QTDEAJUSTE;
            END
            ELSE BEGIN
               SET @V_CUSTPROD =  @V_VLRBRUTAJU;
            END;


            IF (@V_VALRBRUT - (@V_QTLANCTOEST * @V_VRLANCTOBRUT)) < 0 BEGIN
                 SET @V_VALRBRUT = @V_VALRBRUT - (@V_QTLANCTOEST * @V_CUSTPROD);
            END
            ELSE BEGIN
                 SET @V_VALRBRUT = (@V_VALRBRUT - (@V_QTLANCTOEST * @V_VRLANCTOBRUT));
            END;

            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT   = 0;
               SET @V_VALRESTO   = 0;
               SET @V_VALRBRUTM1 = 0;
               SET @V_VALRESTOM1 = 0;
               SET @V_VALRBRUTM2 = 0;
               SET @V_VALRESTOM2 = 0;
            END;
         END;

         WHILE (@V_DTSALDO <= (@V_DTLANCMOVI + 1)) BEGIN
            IF (@V_CDINDICEMF IS NOT NULL) AND (@V_VRINDICE1 <> 0) BEGIN
               SET @V_VALRBRUTM1 = @V_VALRBRUT / @V_VRINDICE1;
               SET @V_VALRESTOM1 = @V_VALRESTO / @V_VRINDICE1;
               SET @V_VRCLOGCONAM1 = @V_VRCLOGCON / @V_VRINDICE1;
               SET @V_VRSEGUCONM1  = @V_VRSEGUCON / @V_VRINDICE1;
            END;

            IF (@V_CDINDICEMF2 IS NOT NULL) AND (@V_VRINDICE2 <> 0) BEGIN
               SET @V_VALRBRUTM2 = @V_VALRBRUT / @V_VRINDICE2;
               SET @V_VALRESTOM2 = @V_VALRESTO / @V_VRINDICE2;
               SET @V_VRCLOGCONAM2 = @V_VRCLOGCON / @V_VRINDICE2;
               SET @V_VRSEGUCONM2  = @V_VRSEGUCON / @V_VRINDICE2;
            END;

            SELECT @V_COUNTPOS = COUNT(*)
            FROM POSESTCONS
            WHERE (CDFILIAL    = @P_FILIMOVI) AND
                  (CDPRODUTO   = @P_PRODUTO) AND
                  (DTPOSESTCON = @V_DTSALDO);

            IF (@V_COUNTPOS = 0) BEGIN
               IF @V_QTDEESTO = 0 BEGIN
                  SET @V_POSIZERO = 'S';
               END
               ELSE BEGIN
                  SET @V_POSIZERO = 'N';
               END;

               IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN

                  INSERT INTO POSESTCONS (CDFILIAL,    CDPRODUTO,    DTPOSESTCON, QTESTDIACON, VRESTDIACON,
                                          VRESTBRUTCON, IDPOSZEROCON, QTESTANTCON, VRESTANTCON,  VRBRUTANTCON,
                                          VRESTDIACOM1,  VRESTBRUTCM1, VRESTANTCOM1, VRBRUTANTCM1, VRESTDIACOM2,
                                          VRESTBRUTCM2, VRESTANTCOM2, VRBRUTANTCM2, VRCLOGCON,    VRCLOGCONANT,
                                          VRCLOGCONM1,  VRCLOGCONAM1, VRCLOGCONM2,  VRCLOGCONAM2, VRSEGUCON,
                                          VRSEGUCONANT, VRSEGUCONM1,  VRSEGUCONAM1, VRSEGUCONM2,  VRSEGUCONAM2)
                                 VALUES (@P_FILIMOVI, @P_PRODUTO,  @V_DTSALDO,
                                         ISNULL(@V_QTDEESTO,0), ISNULL(@V_VALRESTO,0),   ISNULL(@V_VALRBRUT,0),  @V_POSIZERO,
                                         @V_QTDEANTE, @V_VRESTANT,   @V_VRBRUANT, @V_VALRESTOM1, @V_VALRBRUTM1, @V_VRESTANTM1,
                                         @V_VRBRUANTM1, @V_VALRESTOM2, @V_VALRBRUTM2, @V_VRESTANTM2, @V_VRBRUANTM2,
                                         @V_VRCLOGCON,  @V_VRCLOGCONANT, @V_VRCLOGCONM1, @V_VRCLOGCONAM1, @V_VRCLOGCONM2, @V_VRCLOGCONAM2,
                                         @V_VRSEGUCON,  @V_VRSEGUCONANT, @V_VRSEGUCONM1, @V_VRSEGUCONAM1, @V_VRSEGUCONM2, @V_VRSEGUCONAM2);
               END;
            END
            ELSE BEGIN
               IF (@V_DTSALDO < (@V_DTLANCMOVI + 1)) BEGIN
                  IF @V_QTDEESTOPOS = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTCONS
                  SET QTESTDIACON  = ISNULL(@V_QTDEESTOPOS,0),
                      VRESTDIACON  = ISNULL(@V_VALRESTOPOS,0),
                      VRESTBRUTCON = ISNULL(@V_VALRBRUTPOS,0),
                      VRESTDIACOM1 = @V_VALRESTOPOSM1,
                      VRESTBRUTCM1 = @V_VALRBRUTPOSM1,
                      VRESTDIACOM2 = @V_VALRESTOPOSM2,
                      VRESTBRUTCM2 = @V_VALRBRUTPOSM2,
                      IDPOSZEROCON = @V_POSIZERO,
                      QTESTANTCON  = @V_QTDEANTEPOS,
                      VRESTANTCON  = @V_VRESTANTPOS,
                      VRBRUTANTCON = @V_VRBRUANTPOS,
                      VRESTANTCOM1 = @V_VRESTANTPOSM1,
                      VRBRUTANTCM1 = @V_VRBRUANTPOSM1,
                      VRESTANTCOM2 = @V_VRESTANTPOSM2,
                      VRBRUTANTCM2 = @V_VRBRUANTPOSM2,
                      VRCLOGCON     = @V_VRCLOGCON,
                      VRCLOGCONANT  = @V_VRCLOGCONANT,
                      VRCLOGCONM1   = @V_VRCLOGCONM1,
                      VRCLOGCONAM1  = @V_VRCLOGCONAM1,
                      VRCLOGCONM2   = @V_VRCLOGCONM2,
                      VRCLOGCONAM2  = @V_VRCLOGCONAM2,
                      VRSEGUCON     = @V_VRSEGUCON,
                      VRSEGUCONANT  = @V_VRSEGUCONANT,
                      VRSEGUCONM1   = @V_VRSEGUCONM1,
                      VRSEGUCONAM1  = @V_VRSEGUCONAM1,
                      VRSEGUCONM2   = @V_VRSEGUCONM2,
                      VRSEGUCONAM2  = @V_VRSEGUCONAM2
                  WHERE
                      (CDFILIAL    = @P_FILIMOVI)     AND
                      (CDPRODUTO   = @P_PRODUTO)    AND
                      (DTPOSESTCON = @V_DTSALDO);
               END
               ELSE BEGIN
                  IF @V_QTDEESTO = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTCONS
                  SET QTESTDIACON  = ISNULL(@V_QTDEESTO,0),
                      VRESTDIACON  = ISNULL(@V_VALRESTO,0),
                      VRESTBRUTCON = ISNULL(@V_VALRBRUT,0),
                      VRESTDIACOM1 = @V_VALRESTOM1,
                      VRESTBRUTCM1 = @V_VALRBRUTM1,
                      VRESTDIACOM2 = @V_VALRESTOM2,
                      VRESTBRUTCM2 = @V_VALRBRUTM2,
                      IDPOSZEROCON = @V_POSIZERO,
                      QTESTANTCON  = @V_QTDEANTE,
                      VRESTANTCON  = @V_VRESTANT,
                      VRBRUTANTCON = @V_VRBRUANT,
                      VRESTANTCOM1 = @V_VRESTANTM1,
                      VRBRUTANTCM1 = @V_VRBRUANTM1,
                      VRESTANTCOM2 = @V_VRESTANTM2,
                      VRBRUTANTCM2 = @V_VRBRUANTM2,
                      VRCLOGCON     = @V_VRCLOGCON,
                      VRCLOGCONANT  = @V_VRCLOGCONANT,
                      VRCLOGCONM1   = @V_VRCLOGCONM1,
                      VRCLOGCONAM1  = @V_VRCLOGCONAM1,
                      VRCLOGCONM2   = @V_VRCLOGCONM2,
                      VRCLOGCONAM2  = @V_VRCLOGCONAM2,
                      VRSEGUCON     = @V_VRSEGUCON,
                      VRSEGUCONANT  = @V_VRSEGUCONANT,
                      VRSEGUCONM1   = @V_VRSEGUCONM1,
                      VRSEGUCONAM1  = @V_VRSEGUCONAM1,
                      VRSEGUCONM2   = @V_VRSEGUCONM2,
                      VRSEGUCONAM2  = @V_VRSEGUCONAM2
                    WHERE
                      (CDFILIAL    = @P_FILIMOVI)  AND
                      (CDPRODUTO   = @P_PRODUTO) AND
                      (DTPOSESTCON = @V_DTSALDO);
               END;
            END;
            SET @V_DTSALDO  = @V_DTSALDO + 1;
         END;

         /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */
         SET @V_QTDEESTOPOS   = @V_QTDEESTO;
         SET @V_VALRESTOPOS   = @V_VALRESTO;
         SET @V_VALRBRUTPOS   = @V_VALRBRUT;
         SET @V_VALRESTOPOSM1 = @V_VALRESTOM1;
         SET @V_VALRBRUTPOSM1 = @V_VALRBRUTM1;
         SET @V_VALRESTOPOSM2 = @V_VALRESTOM2;
         SET @V_VALRBRUTPOSM2 = @V_VALRBRUTM2;
         SET @V_QTDEANTEPOS   = @V_QTDEANTE;
         SET @V_VRESTANTPOS   = @V_VRESTANT;
         SET @V_VRBRUANTPOS   = @V_VRBRUANT;
         SET @V_VRESTANTPOSM1 = @V_VRESTANTM1;
         SET @V_VRBRUANTPOSM1 = @V_VRBRUANTM1;
         SET @V_VRESTANTPOSM2 = @V_VRESTANTM2;
         SET @V_VRBRUANTPOSM2 = @V_VRBRUANTM2;

         SET @V_LANCESTQ = @V_CDFILIAL  + @V_NRLANCESTOQ + @V_CDALMOXARIFE + @V_CDLOCALESTOQ+
                           @V_NRLOTEESTQ + @V_NRSUBLOTE;

         FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,  @V_VRLANCTOEST,
                                          @V_VRLANCTOBRUT, @V_QTLANCTOEST, @V_IDALTCMEDMV,
                                          @V_CDFILIAL,     @V_NRLANCESTOQ, @V_CDALMOXARIFE,
                                          @V_CDLOCALESTOQ, @V_NRLOTEESTQ,  @V_NRSUBLOTE,
                                          @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN, @V_CDTIPOOPER;
      END;
      CLOSE C_LANCTOEST;
      DEALLOCATE C_LANCTOEST;

      UPDATE POSESTCONS
      SET VRESTDIACON  = 0,
          VRESTBRUTCON = 0,
          VRESTDIACOM1 = 0,
          VRESTBRUTCM1 = 0,
          VRESTDIACOM2 = 0,
          VRESTBRUTCM2 = 0,
          VRCLOGCON     = 0,
          VRCLOGCONM1   = 0,
          VRCLOGCONM2   = 0,
          VRSEGUCON     = 0,
          VRSEGUCONM1   = 0,
          VRSEGUCONM2   = 0

      WHERE (CDFILIAL     = @P_FILIMOVI) AND
            (CDPRODUTO    = @P_PRODUTO) AND
            (DTPOSESTCON >= @P_DTINICIAL) AND
            (QTESTDIACON  = 0);

      UPDATE POSESTCONS
      SET VRESTANTCON  = 0,
          VRBRUTANTCON = 0,
          VRESTANTCOM1 = 0,
          VRBRUTANTCM1 = 0,
          VRESTANTCOM2 = 0,
          VRBRUTANTCM2 = 0,
          VRCLOGCONANT  = 0,
          VRCLOGCONAM1  = 0,
          VRCLOGCONAM2  = 0,
          VRSEGUCONANT  = 0,
          VRSEGUCONAM1  = 0,
          VRSEGUCONAM2  = 0
      WHERE (CDFILIAL     = @P_FILIMOVI) AND
            (CDPRODUTO    = @P_PRODUTO) AND
            (DTPOSESTCON >= @P_DTINICIAL) AND
            (QTESTANTCON  = 0);

   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_ESTOQUE_CONS','5.05.086';
GO
